import Foundation
class LoginViewModel {
	
	var username: String = ""
	var password: String = ""
	var loginState = false {
		didSet {
			self.loginStateChanged?(loginState)
		}
	}
	
	let loginURL = "http://study.ck.tp.edu.tw/login_chk.asp"
	let requestBody = "f_mnuid=&f_uid=%@&f_pwd=%@&submit=%B5n%A4J"
	
	var showLoginFailedAlert: ((String, String) -> Void)? = nil
	var loginStateChanged: ((Bool) -> Void)? = nil
	var loginSuccessfully: (() -> Void)? = nil
	
	func login() {
		loginState = true
		var request = URLRequest(url: URL(string: loginURL)!)
		request.httpMethod = "POST"
		let cfEnc = CFStringEncodings.big5
		let nsEnc = CFStringConvertEncodingToNSStringEncoding(CFStringEncoding(cfEnc.rawValue))
		let big5encoding = String.Encoding(rawValue: nsEnc)
		let body = String(format: requestBody, username, password)
		request.httpBody = body.data(using: big5encoding)
		URLSession.shared.dataTask(with: request) { data, response, error in
			self.handleData(string: String(data: data!, encoding: big5encoding)!)
			self.loginState = false
		}.resume()
	}
	
	private func handleData(string data: String) {
		print(data)
		//this condition is for testing purpose
		if username == "tUsername" && password == "tPassword" {
			loginSuccessfully?()
		} else if data.contains("密碼錯誤") {
			showLoginFailedAlert?("錯誤", "密碼錯誤，請再試一次")
		} else if data.contains("帳號") && data.contains("不存在") {
			showLoginFailedAlert?("錯誤", "帳號\(username)不存在")
		} else { //login successfully
			loginSuccessfully?()
		}
	}
}
